/* $Id: fullfactor_init.gp,v 1.7 2009-11-24 11:37:24 jdemeyer Exp $ */

fullfactor_initialise() =
{
	/* Where to find the fullfactor data, add a '/' at the end. */
	fullfactor_datadir = "";

	/* Try the following directories: */
	my(t = Str(default(datadir), ":", default(path), ":"));
	t = Vec(t);
	my(d = "");
	for (i = 1, #t,
		/* Read directory name from `t' char by char */
		if (t[i] != ":", d = Str(d, t[i]); next);

		/* Try directory `d' */
		if (Vec(d)[#d] != "/", d = Str(d, "/"));
		d = Strexpand(d, "data/fullfactor/");
		if (trap(,0,readvec(Str(d, "cyclo2.3"))),
			/* Success! */
			fullfactor_datadir = d;
			break;
		);

		d = "";
	);
	
	if (fullfactor_datadir == "",
		warning("No fullfactor data found, can only do partial cyclotomic factorisations.");
	);

	/* Which bases to check by default?  Set this using the
	 * factor_cyclo_bases() function, defined in fullfactor_bases.gp */
	factor_cyclo_setbases(99);

	/* Install some needed libPARI functions. */
	install(vconcat,"GG");
	install(gcmp, "iGG");
	install(cmp_padic, "iGG");

	/* Prevent this initialisation from happening twice
	 * when the users read this file again. */
	fullfactor_initialised = "yes";

	return;
}

if (fullfactor_initialised != "yes", fullfactor_initialise());
